#!/bin/bash

#script to install exim and friends (majordomo)

SCRIPTPATH=/usr/local/directadmin/scripts
cd $SCRIPTPATH

. ./files.sh

#remove any conflicting packages here
dpkg -r --force-all exim4 exim4-base exim4-config exim4-daemon-light exim4-config-2 exim4-daemon-heavy rmail sendmail-bin sendmail mail-transport-agent postfix ssmtp courier-authdaemon courier-authlib courier-authlib-userdb courier-base courier-imap courier-imap-ssl courier-maildrop courier-pop courier-pop-ssl courier-ssl
dpkg -P exim4 exim4-base exim4-config exim4-daemon-light exim4-config-2 exim4-daemon-heavy rmail sendmail-bin sendmail mail-transport-agent postfix ssmtp courier-authdaemon courier-authlib courier-authlib-userdb courier-base courier-imap courier-imap-ssl courier-maildrop courier-pop courier-pop-ssl courier-ssl

if [ -e /etc/exim.conf ]; then
	mv -f /etc/exim.conf /etc/exim.conf.moved
fi

cd ./packages

#install what we've got

dpkg -i $exim

COUNT=`dpkg --get-selections | grep -c -e '^exim'`;
if [ $COUNT = 0 ]
then
	echo "*** exim not installed: aborting. ***";
        exit 1;
fi

perl -pi -e 's/^pop/\#pop/' /etc/inetd.conf
killall -HUP inetd


#ensure permissions:
SPOOL=/var/spool/exim
if [ -e "$SPOOL" ]; then
	chown -R mail:mail $SPOOL
fi

DOVECOT=0
CUSTOMBUILD=0
if [ -e /root/.custombuild ]; then
        CUSTOMBUILD=1

        OP=/usr/local/directadmin/custombuild/options.conf

        if [ -e $OP ]; then
                TDOVECOT=`grep -c dovecot=yes $OP`
        else
                TDOVECOT=1
        fi

        if [ "$TDOVECOT" -eq 1 ]; then
                DOVECOT=1
        fi
fi

#added August 24, 2010
#we're going to update the exim.conf files.
#patch if dovecot is on.  the 1=1 is so we can turn it off easily.
if [ "1" = "1" ]; then

	EC=/etc/exim.conf
	EP=/etc/exim.pl

        wget -O ${EC}.temp http://files.directadmin.com/services/exim.conf
        wget -O ${EP}.temp http://files.directadmin.com/services/exim.pl

        if [ -s ${EC}.temp ]; then
                cp -f ${EC}.temp ${EC}

                #this file may not exist yet.
                P=/usr/local/directadmin/custombuild/exim.conf.dovecot.patch
                if [ "$DOVECOT" -eq 1 ] && [ -e ${P} ]; then
                        patch -p0 < ${P}
                fi

                echo "";
                echo "*** Your /etc/exim.conf has been updated to the latest version ***";
                echo "";
        fi

        if [ -s ${EP}.temp ]; then
                cp -f ${EP}.temp ${EP}
                chmod 755 ${EP}
        fi
fi

if [ "$DOVECOT" -eq 0 ]; then
	dpkg -i $vm_pop3d
	update-rc.d vm-pop3d defaults
	/etc/init.d/vm-pop3d start

	${SCRIPTPATH}/imapd.sh
fi

cd ${SCRIPTPATH}/packages
tar xzf majordomo-*.tar.gz
cd ..
./majordomo.sh

#pop before smtp
cp -f /usr/local/directadmin/data/templates/da-popb4smtp /etc/init.d/da-popb4smtp
chmod 755 /etc/init.d/da-popb4smtp
update-rc.d da-popb4smtp defaults
/etc/init.d/da-popb4smtp start

if [ "$CUSTOMBUILD" -eq 0 ]; then

	#Removed Nov 30, 2009
	#${SCRIPTPATH}/webmail.sh

	${SCRIPTPATH}/squirrelmail.sh

	wget -O ${SCRIPTPATH}/roundcube.sh http://files.directadmin.com/services/all/roundcube.sh
	chmod 755 ${SCRIPTPATH}/roundcube.sh
	${SCRIPTPATH}/roundcube.sh
fi

#${SCRIPTPATH}/spam.sh

