#!/bin/sh

#Mysql installer script

CWD=/usr/local/directadmin/scripts
SQLDIR=/home/mysql

CMD_LINE=0;
if [ $# -gt 3 ]; then
        CMD_LINE=$4
fi

installMySQL() {

        #/usr/sbin/pw groupadd mysql 2> /dev/null
        #/usr/sbin/pw useradd -g mysql -n mysql 2> /dev/null
	adduser --system --group --home /usr/local/mysql --no-create-home \
                --disabled-login --force-badname mysql 2> /dev/null

	cd $CWD
	. ./files.sh

	if [ "$mysql_standard" = "" ]; then
		echo "your files.sh has returned an empty value for mysql_standard.  Ensure your files.sh is not empty.";
		exit 1;
	fi

	GZ=`echo $mysql_standard | cut -d. -f6`
	if [ "$GZ" = "gz" ]; then
		NAME=`echo $mysql_standard | cut -d. -f1,2,3,4`
	else
		NAME=`echo $mysql_standard | cut -d. -f1,2,3`
	fi

	if [ "$NAME" = "" ]; then
		NAME=mysql-5.0.67-linux-i686
	fi

        FILE=${CWD}/packages/${NAME}.tar.gz

        if [ ! -e $FILE ]
        then
                echo "*** Unable to find $FILE to extract ***";
                exit 1;
        fi

        cd /usr/local
        /bin/tar xzf $FILE
        ln -sf $NAME mysql
        cd mysql
        if [ ! -e $SQLDIR ]
        then
                mkdir -p $SQLDIR
		chown 711 $SQLDIR
                chown -R mysql:mysql $SQLDIR
        fi

        rm -rf data
        ln -sf $SQLDIR data

        scripts/mysql_install_db

        chown -R root  .
        chown -R mysql data
        chgrp -R mysql .
        chown -R mysql:mysql $SQLDIR

        ln -sf /usr/local/mysql/bin/mysql /usr/local/bin/mysql
        chmod 755 /usr/local/bin/mysql

        ln -sf /usr/local/mysql/bin/mysqladmin /usr/local/bin/mysqladmin
        chmod 755 /usr/local/bin/mysqladmin


	if [ ! -e /etc/ld.so.conf ] || [ "`grep -c -E '/usr/local/mysql/lib$' /etc/ld.so.conf`" = "0" ]; then
	        echo "/usr/local/mysql/lib" >> /etc/ld.so.conf
	        ldconfig
	fi


}

#have to change the name of the startup script so that dataskq can find it
#(has to have same name as the process)

setStartupScript() {
        if [ ! -e /etc/init.d/mysqld ]
        then
                cp -f ${CWD}/mysqld /etc/init.d/mysqld
                chmod 755 /etc/init.d/mysqld
		update-rc.d mysqld defaults
        fi
}

setRootPass() {

        /usr/local/mysql/bin/mysqladmin --user=root password $1 1> /dev/null 2> /dev/null
        echo "UPDATE mysql.user SET password=PASSWORD('${1}') WHERE user='root';"> mysql.temp;
        echo "UPDATE mysql.user SET password=PASSWORD('${1}') WHERE password='';">> mysql.temp;
	echo "DROP DATABASE IF EXISTS test;" >> mysql.temp
        echo "FLUSH PRIVILEGES;" >> mysql.temp;
        /usr/local/mysql/bin/mysql mysql --user=root --password=${1} < mysql.temp;
        rm -f mysql.temp;
}

setDAuser() {

        FILE="/usr/local/directadmin/conf/mysql.conf"

        echo "user=${2}" > $FILE
        echo "passwd=${3}" >> $FILE

        chown -f diradmin:diradmin $FILE;
        chmod -f 400 $FILE;

        #ok, now we'll create a temp file and run mysql that way.

        echo "GRANT CREATE, DROP ON *.* TO ${2}@localhost IDENTIFIED BY '${3}' WITH GRANT OPTION;" > mysql.temp;
        echo "GRANT ALL PRIVILEGES ON *.* TO ${2}@localhost IDENTIFIED BY '${3}' WITH GRANT OPTION;" >> mysql.temp;

        #echo "Enter the password for the root user of MySQL: ";

        /usr/local/mysql/bin/mysql --user=root --password=${1} < mysql.temp;

        rm -f mysql.temp;
}

checkMySQLdir() {
        if [ -e ${SQLDIR} ]
        then
                if [ $CMD_LINE -eq 1 ]; then
                        rm -rf ${SQLDIR};
                else
                echo "";
                echo "*****************************************************";
                echo "*****************************************************";
                echo "";
                echo "It seems as though mysql has already been installed.";
                echo "The directory ${SQLDIR} has been found.  For the best results, its recommended that this be deleted.";
                echo "All database data will be lost if you delete it";
                echo "";
                echo -n "Do you want to delete it? (y is recommended)? (y,n) : ";
                read yesno;
                echo "";
                if [ "$yesno" != "n" ]
                then
                        rm -rf ${SQLDIR};
                fi
                fi
        fi
}

if [ $# -lt "3" ]
then
        echo "Usage: $0 mysqlrootpass da_dbuser da_pass";
        echo "*** do not use spaces in your passwords ***";
        exit 1;
fi

#stop taskq from trying
SERVICES=/usr/local/directadmin/data/admin/services.status
if [ -e $SERVICES ]
then
        /usr/bin/perl -pi -e 's/mysqld=ON/mysqld=OFF/' ${SERVICES};
fi

/etc/init.d/mysqld stop 2> /dev/null
/usr/bin/killall mysqld 2> /dev/null

if [ -d /etc/mysql ]; then
	mv /etc/mysql /etc/mysql.moved 2> /dev/null
fi

checkMySQLdir

#Install mysql

installMySQL

setStartupScript

/etc/init.d/mysqld start

echo "Waiting for mysqld to start....";
sleep 7

#echo "Setting MySQL Root Password...";
setRootPass $1;
#echo "Setting DirectAdmin user and password...";
setDAuser $1 $2 $3;

exit 0;
