#!/bin/bash
#Script to setup the base file for proftpd

IP=`cat ./setup.txt | grep ip= | cut -d= -f2`;
VH="/etc/proftpd.vhosts.conf"

COUNT=`grep -c -e '^ftp:' /etc/group`
if [ "$COUNT" -eq 0 ]; then
	groupadd ftp
fi

COUNT=`grep -c -e '^ftp:' /etc/passwd`
if [ "$COUNT" -eq 0 ]; then
	/usr/sbin/adduser --system --group --firstuid 100 --home /home/ftp --no-create-home --disabled-login --force-badname ftp 2> /dev/null
fi


touch ${VH}
touch /etc/proftpd.passwd
chown -f root:ftp /etc/proftpd.passwd;
chmod -f 640 /etc/proftpd.passwd
chmod -f 644 ${VH}
mkdir /var/log/proftpd
mkdir /var/run/proftpd


SCRIPTPATH=/usr/local/directadmin/scripts
cd $SCRIPTPATH

. ./files.sh

cd ./packages

#get rid of anything in the way:

dpkg -r --force-all gadmin-proftpd gforge-ftp-proftpd gproftpd proftpd-basic proftpd-doc proftpd-mod-ldap proftpd-mod-mysql proftpd-mod-pgsql
dpkg -P gadmin-proftpd gforge-ftp-proftpd gproftpd proftpd-basic proftpd-doc proftpd-mod-ldap proftpd-mod-mysql proftpd-mod-pgsql


#install what we've got
dpkg -i $proftpd

COUNT=`dpkg --get-selections | grep -c -e '^proftpd'`;
if [ $COUNT = 0 ]
then
        echo "*** proftpd not installed: aborting. ***";
        exit 1;
fi

exit 0;
